export default class Container {
  private services: Map<Function, any> = new Map();

  set<T>(type: new (...args: any[]) => T, instance: T): void {
    this.services.set(type, instance);
  }

  get<T>(type: new (...args: any[]) => T): T {
    const instance = this.services.get(type);
    if(!instance)
      throw new Error(`Service of type "${type.name}" not found.`);
    return instance;
  }
}
